#pragma once

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-macros"

#define ZYRE_BUILD_DRAFT_API

#define SPDLOG_FMT_EXTERNAL
#include <spdlog/spdlog.h>
#include <spdlog/sinks/stdout_color_sinks.h>
#include <spdlog/sinks/basic_file_sink.h>

#define salsa_NAME "salsa"

#define salsa_MAKE_VERSION(major, minor, patch) (((major) << 22) | ((minor) << 12) | (patch))
#define salsa_VERSION_MAJOR(version) (static_cast<uint32_t>(version) >> 22)
#define salsa_VERSION_MINOR(version) ((static_cast<uint32_t>(version) >> 12) & 0x3ff)
#define salsa_VERSION_PATCH(version) (static_cast<uint32_t>(version) & 0xfff)
#define salsa_VERSION_TWEAK "1"

#define salsa_VERSION salsa_MAKE_VERSION(0, 7, 1)

#include "Object.hh"

#define SALSA_INT_N_PROXY_(str) #str
#define SALSA_INT_N_(str) SALSA_INT_N_PROXY_(str)

#ifndef __FILENAME__
#define __FILENAME__ __FILE__
#endif

#define SPD_TRACE(...)    ::Salsa::Object::getConsoleOutput()->trace   (__FILENAME__  ":" SALSA_INT_N_(__LINE__) ": " __VA_ARGS__)
#define SPD_DEBUG(...)    ::Salsa::Object::getConsoleOutput()->debug   (__FILENAME__  ":" SALSA_INT_N_(__LINE__) ": " __VA_ARGS__)
#define SPD_INFO(...)     ::Salsa::Object::getConsoleOutput()->info    (__VA_ARGS__)
#define SPD_WARN(...)     ::Salsa::Object::getConsoleOutput()->warn    (__FILENAME__  ":" SALSA_INT_N_(__LINE__) ": " __VA_ARGS__)
#define SPD_ERROR(...)    ::Salsa::Object::getConsoleOutput()->error   (__FILENAME__  ":" SALSA_INT_N_(__LINE__) ": " __VA_ARGS__)
#define SPD_CRIT(...)     ::Salsa::Object::getConsoleOutput()->critical(__FILENAME__  ":" SALSA_INT_N_(__LINE__) ": " __VA_ARGS__)

#define TUI_CP_SCR 1
#define TUI_CP_WIN 2
#define TUI_CP_WIN_REV 3
#define TUI_CP_OK 4
#define TUI_CP_ERR 5
#define TUI_CP_RUN 6
#define TUI_CP_TOT 7
#define TUI_CP_SHADOW 8
#define TUI_CP_HEAD 9


#pragma clang diagnostic pop
